package LATMOS::Accounts::Web::Controller::Ajax::Services::Mailing;
use Moose;
use namespace::autoclean;

BEGIN { extends 'Catalyst::Controller'; }

=head1 NAME

LATMOS::Accounts::Web::Controller::Ajax::Services::Mailing - Catalyst Controller

=head1 DESCRIPTION

Catalyst Controller.

=head1 METHODS

=cut


=head2 index

=cut

sub index :Path :Args(0) {
    my ( $self, $c ) = @_;

    $c->response->body('Matched LATMOS::Accounts::Web::Controller::Ajax::Services::Mailing in Ajax::Services::Mailing.');
}

sub users_list :Local {
    my ( $self, $c ) = @_;

    $c->req->params->{attr} =    [ 'active', 'mail' ];
    $c->req->params->{attrval} = [ '1',    , '*'    ];

    for ($c->req->param('type')) {

        /^dpmt$/ and do {
            push(@{ $c->req->params->{attr} }, 'department');
            push(@{ $c->req->params->{attrval} }, $c->req->param('obj'));
            last;
        };
        /^dpmt_assoc$/ and do {
            push(@{ $c->req->params->{attr} }, 'memberOf');
            push(@{ $c->req->params->{attrval} }, $c->req->param('obj'));
            last;
        };
        /^quick$/ and do {
            last;
        };

        # Else
        push(@{ $c->req->params->{attr} }, $_);
        push(@{ $c->req->params->{attrval} }, $c->req->param('toto'));
    }
    $c->stash->{ofilter} = $c->model('AttrFilter', 'user');
}

sub dest_list :Private {}

sub quick_input :Private {}

sub empty :Local {
    my ( $self, $c ) = @_;
    $c->session->{to} = {};
    $c->go('dest_list');
}

sub mod_to :Local {
    my ( $self, $c ) = @_;

    for ($c->req->param('act' || '')) {
        /add_to/ and do {
            foreach ($c->req->param('user')) {
                $c->session->{to}{$_} = 1;
            }
        };
        /remove_to/ and do {
            foreach ($c->req->param('user')) {
                delete($c->session->{to}{$_});
            }
        };
    }

    $c->go('dest_list');
}

sub attachments :Local {
    my ( $self, $c ) = @_;
    foreach ($c->req->param('rm_attachment')) {
        $c->session->{mailing}{attachments}[$_ -1] = undef;
    }

    $c->session->{mailing}{attachments} = [
        grep { $_ }
        @{
        $c->session->{mailing}{attachments} || []}
    ];
}

sub end : Private {
    my ( $self, $c ) = @_;
    $c->forward($c->view('TTpart'));
}

=head1 AUTHOR

olivier

=head1 LICENSE

This library is free software. You can redistribute it and/or modify
it under the same terms as Perl itself.

=cut

__PACKAGE__->meta->make_immutable;

1;
